import java.util.Scanner;

/* NB: For the judge to run the program, do not modify the declaration of the class Main or
 *     method main() below. The class has to be declared as "class Main { ... }"
 *     and the method as "public static void main(String[] args) { ... }" */
class Main {

	public static void main(String[] args) {

		// Read from the standard input with java.util.Scanner
		Scanner scanner = new Scanner(System.in);
		
		// Read the number of cases and loop over the cases
		int case_no, cases = scanner.nextInt();
		for (case_no = 0; case_no < cases; case_no++) {
			
			// Read the matrix size
			int n = scanner.nextInt();
			
			// Create a new 2D array
			int[][] A = new int[n][n]; 
			
			// Read the matrix
			int i, j;
			for (i = 0; i < n; i++) {
				for (j = 0; j < n; j++) {
					A[i][j] = scanner.nextInt();
				}
			}
			
			// Globally best sum we have seen
			// Note that we do not need to look at 0x0 matrices below
			int maxsum = 0;
			
			int top, bottom;
			
			// Try all rows as the first row of the submatrix
			for (top = 0; top < n; top++) {
				// The sums of the sub-columns A[top .. bottom, j]
				int[] columns = new int[n];
				for (j = 0; j < n; j++)
					columns[j] = 0;
				
				// Try all rows from "top" as the bottom row
				for (bottom = top; bottom < n; bottom++) {
					// Update "columns" to contain the sum with the current "bottom"
					for (j = 0; j < n; j++)
						columns[j] += A[bottom][j];
					
					// Run the "subarray sum" algorithm on the "columns" array
					int cursum = 0;
					for (j = 0; j < n; j++) {
						cursum += columns[j];
						if (cursum < 0)
							cursum = 0;
						if (cursum > maxsum)
							maxsum = cursum;
					}
					
				}
			}
			
			System.out.println(maxsum);
		}
		scanner.close();
	}
}
